<?php
/***************************************************
 * 模块定义:
 * 定义媒体管理部分的API
 **************************************************/
class MediaController extends ServerController {
	
	//文件类型
	const MediaImageIndexCelt = 0; //音频
	const MediaImageIndexAudio = 1; //音频（暂时不知和0的区别）
	const MediaImageIndexVedio = 2; //视频
	const MediaImageIndexUrl = 3; //节目源
	const MediaImageIndexGroup = 4; //文件夹
	

	//	/**
	//	 * 获取媒体树 
	//	 */
	//	public function actionListMediaTree() {
	//		
	//		$UserID = $this->GetPostOwnerID ();
	//		
	//		if (! is_null ( $UserID ) && $UserID < 0) {
	//			//用户无效
	//			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
	//			return;
	//		}
	//		if ($UserID > 0) { //说明是登录用户，没有树
	//			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array () );
	//			return;
	//		}
	//		$sql = "select MediaID as id, FileName as text, Parent from MediaFiles where FileSize = 0 and FileFmt >= 0";
	//		
	//		if (! is_null ( $UserID ) && $UserID > 0) {
	//			$sql .= ' AND Owner=' . $UserID;
	//		}
	//		$result = DBMethodUtils::listData ( $sql );
	//		
	//		if (is_null ( $result ) || count ( $result ) <= 0) {
	//			echo "";
	//			return;
	//		}
	//		$bta = new BuildTreeArray ( $result, 'id', 'Parent', 0 );
	//		$data = $bta->getTreeArray ();
	//		
	//		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $data );
	//	}
	//	
	/**
	 * 获取媒体资源文件
	 */
	public function actionListMedias() {
		
		//////////////////////////////////////////////
		// 1、管理员可以常看所有的媒体文件
		// 2、非管理员只能查看自己的媒体文件
		//////////////////////////////////////////////
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT * FROM MediaFiles";
		
		$hasParent = false;
		
		if (isset ( $DataParam ['Parent'] )) { //根据父节点筛选
			$parent = $DataParam ['Parent'];
			
			if (is_numeric ( $parent )) {
				
				if ($parent == 0) {
					$sql = $sql . " WHERE ISNULL(Parent)";
				} else {
					$sql = $sql . " WHERE Parent='" . $parent . "'";
				}
				$hasParent = true;
			}
		}
		
		if (! $hasParent) { //获取一级目录
			if (is_null ( $UserID ) || $UserID == 0) { //超级管理员登录
				$sql = $sql . " WHERE (ISNULL(Parent) OR LENGTH(Parent) <= 0)";
			} else { //普通给用户登录，只能够获取到自己的
				$sql = $sql . " WHERE Parent IN(SELECT MediaID FROM MediaFiles WHERE Parent IN(SELECT MediaID FROM MediaFiles WHERE ISNULL(Owner) AND Sysfolder = 2) 
					AND Owner = " . $UserID . " AND Sysfolder = 1)";
			}
		}
		
		//		if (! is_null ( $UserID ) && $UserID > 0) { //非管理员用户登录
		//			if (! $hasParent) {
		//				$sql .= ' WHERE (Parent IN (SELECT MIN(MediaID) FROM MediaFiles WHERE TotalTime = 0 AND Owner="' . $UserID . '"))';
		//			}
		//		} else {
		//			if ($hasParent == false) {
		//				$sql .= " WHERE Parent is null";
		//			}
		//		}
		

		if (isset ( $DataParam ['IsVideo'] ) && is_numeric ( $DataParam ['IsVideo'] )) { //根据音视频类型筛选, 1:视频，0：音频
			if ($DataParam ['IsVideo'] == 1) { //视频
				$sql .= ' AND (FileFmt IN(-1,2,3,4) OR (FileSize=0 AND TotalTime=0 AND FileFmt=0))';
			} else if ($DataParam ['IsVideo'] == 0) { //音频
				$sql .= ' AND (FileFmt IN(0,1) OR (FileSize=0 AND TotalTime=0 AND FileFmt=0))';
			}
		}
		$ParamArr = array();
		if (isset ( $DataParam ['SearchKey'] )) { //按照关键字搜索
			$ParamArr[':SearchKey'] = $DataParam ['SearchKey'];
			$sql .= ' AND FileName LIKE CONCAT("%", :SearchKey, "%")';
		}
		$sql .= '  ORDER BY TotalTime ASC';
		
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size )) {
				$sql .= '  LIMIT ' . $start . ', ' . $size;
			}
		}
		
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		
		$Out = array ();
		
		if (! empty ( $result )) {
			foreach ( $result as $value ) {
				if ($value ['TotalTime'] == 0) {
					$value ['FileType'] = self::MediaImageIndexGroup;
				} else {
					switch ($value ['FileFmt']) {
						case 0 :
							$value ['FileType'] = self::MediaImageIndexCelt;
							break;
						case - 1 :
							$value ['FileType'] = self::MediaImageIndexUrl;
							break;
						default :
							if ($value ['VedioCodec'] == - 1) {
								$value ['FileType'] = self::MediaImageIndexAudio;
							} else {
								$value ['FileType'] = self::MediaImageIndexVedio;
							}
							break;
					}
				}
				
				$Out [] = $value;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}
}